
using System;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Threading;
using ClarionSimulation;
using WorldServerLibrary;
using WorldServerLibrary.Model;
using WorldServerLibrary.Exceptions;

namespace ClarionDEMO
{
	class MainClass
	{
		#region properties
		private WorldServer worldServer = null;
        private ClarionAgent agent;
        String creatureId = String.Empty;
        String creatureName = String.Empty;

		Creature criatura = new Creature (); //IA006 - André A. Silva
		List<Thing> joias = new List<Thing> ();	//IA006 - André A. Silva
		Thing joia = new Thing (); //IA006 - André A. Silva
		Thing comida = new Thing (); //IA006 - André A. Silva
		string jewelName; //IA006 - André A. Silva
		string foodName; //IA006 - André A. Silva
		double coord_x = 0; //IA006 - André A. Silva
		double coord_y = 0; //IA006 - André A. Silva

		Boolean entregar = false;//IA006 - André A. Silva

		double prad = 0;
		#endregion

		#region constructor
		public MainClass() {
			Console.WriteLine ("Clarion Demo V0.4");
			agent = new ClarionAgent();
            agent.OnNewVisualSensorialInformation += new InputVisualSensorialInformationEventHandler(agent_OnNewVisualSensorialInformation);
            agent.OnNewExternalActionSelected += new OutputActionChunkEventHandler(agent_OnNewExternalActionSelected);
			try
            {
                worldServer = new WorldServer("localhost", 4011);
                String message = worldServer.Connect();

                if (worldServer != null && worldServer.IsConnected)
                {
                    Console.Out.WriteLine ("[SUCCESS] " + message + "\n");
                    worldServer.NewCreature(600, 400, 0, out creatureId, out creatureName);
					worldServer.SendCreateLeaflet();
                    worldServer.NewBrick(4, 747, 2, 800, 567);
                    worldServer.NewBrick(4, 50, -4, 747, 47);
                    worldServer.NewBrick(4, 49, 562, 796, 599);
                    worldServer.NewBrick(4, -2, 6, 50, 599);


					//IA006 - André A. Silva - início - Criar jóias e comidas
					Random rnd = new Random();
//					int rnd_jewel = rnd.Next(0,5);
					int rnd_X = rnd.Next(100, 800);
					int rnd_Y = rnd.Next(100, 600);
					worldServer.NewJewel(0,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(1,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(2,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(3,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(4,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(5,rnd_X,rnd_Y);

					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(0,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(1,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(2,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(3,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(4,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(5,rnd_X,rnd_Y);


					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(0,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(1,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(2,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(3,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(4,rnd_X,rnd_Y);
					rnd_X = rnd.Next(100, 700);
					rnd_Y = rnd.Next(100, 500);
					worldServer.NewJewel(5,rnd_X,rnd_Y);

					//IA006 - André A. Silva - fim da criação de jóias e comidas


                    if (!String.IsNullOrWhiteSpace(creatureId))
                    {
                        worldServer.SendStartCamera(creatureId);
                        worldServer.SendStartCreature(creatureId);
                    }

                    Console.Out.WriteLine("Creature created with name: " + creatureId + "\n");
                    agent.Run();
					Console.Out.WriteLine("Running Simulation ...\n");
                }
            }
            catch (WorldServerInvalidArgument invalidArtgument)
            {
                Console.Out.WriteLine(String.Format("[ERROR] Invalid Argument: {0}\n", invalidArtgument.Message));
            }
            catch (WorldServerConnectionError serverError)
            {
                Console.Out.WriteLine(String.Format("[ERROR] Is is not possible to connect to server: {0}\n", serverError.Message));
            }
            catch (Exception ex)
            {
                Console.Out.WriteLine(String.Format("[ERROR] Unknown Error: {0}\n", ex.Message));
            }
		}
		#endregion

		#region Methods
		public static void Main (string[] args)	{
			new MainClass();
		}

        IList<Thing> agent_OnNewVisualSensorialInformation()
        {
            IList<Thing> response = null;


            if (worldServer != null && worldServer.IsConnected)
            {
				//IA006 - André A. Silva - A variável "response" pega toda a string que identifica o mundo que o agente vê
                response = worldServer.SendGetCreatureState(creatureName);

				//IA006 - André A. Silva - selecionando a jóia mais próxima;
				if (response.Any (item => (item.CategoryId == Thing.CATEGORY_JEWEL))) {
					joia = (Thing) response.Where(item => (item.CategoryId == Thing.CATEGORY_JEWEL)).OrderBy(item => item.DistanceToCreature).First ();
					joias.Add (joia);
					jewelName = joia.Name;
					coord_x = joia.X1;
					coord_y = joia.Y1;
				}

				//IA006 - André A. Silva - selecionando a comida mais próxima;
				if (response.Any (item => (item.CategoryId == Thing.CATEGORY_FOOD || item.CategoryId == Thing.categoryPFOOD || item.CategoryId == Thing.CATEGORY_NPFOOD ))) {
					comida = (Thing) response.Where(item => (item.CategoryId == Thing.CATEGORY_FOOD || item.CategoryId == Thing.categoryPFOOD || item.CategoryId == Thing.CATEGORY_NPFOOD) ).OrderBy(item => item.DistanceToCreature).First ();

				    foodName = comida.Name;
					coord_x = comida.X1;
					coord_y = comida.Y1;
				}

				prad = (Math.PI / 180) * response.First().Pitch;
				while (prad > Math.PI) prad -= 2 * Math.PI;
				while (prad < - Math.PI) prad += 2 * Math.PI;

				Sack s = worldServer.SendGetSack("0");

				//IA006 - André A. Silva - fazendo a contabilidade dos cristais coletados.
				criatura.SetCollectedBLUE (s.blue_crystal);
				criatura.SetCollectedGREEN (s.green_crystal);
				criatura.SetCollectedMAGENTA (s.magenta_crystal);
				criatura.SetCollectedRED (s.red_crystal);
				criatura.SetCollectedWHITE (s.white_crystal);
				criatura.SetCollectedYELLOW (s.yellow_crystal);


				entregar = criatura.Posso_entregar ();

            }
            return response;
        }

        void agent_OnNewExternalActionSelected(ClarionAgentActionType externalAction)
        {   Thread.CurrentThread.CurrentCulture = new CultureInfo("en-US");
            if (worldServer != null && worldServer.IsConnected)
            {
                switch (externalAction)
                {
                case ClarionAgentActionType.DO_NOTHING:
                        // Do nothing as the own value says
//					Console.WriteLine ("DO_NOTING");
                    break;
                case ClarionAgentActionType.ROTATE_CLOCKWISE:
//					Console.WriteLine ("ROTATE_CLOCKWISE");
					double newprad = prad + Math.PI/1000;
					while (newprad > Math.PI) newprad -= 2 * Math.PI;
			        while (newprad < - Math.PI) newprad += 2 * Math.PI;
                    worldServer.SendSetAngle(creatureId, 0, 0, newprad);
                    break;
				case ClarionAgentActionType.GO_AHEAD:
//					Console.WriteLine ("GO_AHEAD");
                    worldServer.SendSetAngle(creatureId, 1, 1, prad);
					worldServer.SendSetGoTo (creatureId, 0.5, 0.5, coord_x, coord_y);//IA006 - André A. Silva

					//IA006 - André A. Silva - Se os Leaflets estiverem completos, podemos entregar
					if (entregar) {
						worldServer.SendSetGoTo (creatureId, 0.5, 0.5, 50, 50);
					}
                    break;
				case ClarionAgentActionType.MOVE_IT://IA006 - André A. Silva
//					Console.WriteLine ("MOVE_IT");//IA006 - André A. Silva
					worldServer.SendSetAngle(creatureId, 1, 1, prad);
					worldServer.SendSetGoTo(creatureId, 0.5, 0.5, coord_x, coord_y);//IA006 - André A. Silva
					break;

				case ClarionAgentActionType.SACK_IT://IA006 - André A. Silva
//					Console.WriteLine ("SACK_IT");//IA006 - André A. Silva
					if (joia.DistanceToCreature < 40) {
						worldServer.SendSackIt (creatureId, jewelName);
					} //IA006 - André A. Silva
					break;
				case ClarionAgentActionType.EAT_IT://IA006 - André A. Silva
//					Console.WriteLine ("EAT_IT");//IA006 - André A. Silva
					if (comida.DistanceToCreature < 40) {
						worldServer.SendEatIt (creatureId, foodName);
					}//IA006 - André A. Silva
					break;

				default:
                        break;
                }
            }
        }

        #endregion
	}
	
	
}
