﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace WorldServerLibrary.Model
{
	public enum MotorSystemType
	{
		CAR,
		TWO_WHEEL
	}

	public class Creature:Thing
	{
		public Int32 index { get; set; }
		public MotorSystemType MotorSystem { get; set; }
		public double Wheel { get; set; }
		public double Speed { get; set; }
		public double Fuel { get; set; }
		public double serotonin { get; set; }
		public double endorphine { get; set; }
		public Boolean HasLeaflet { get; set; }
		public Int32 NumberOfLeaflets { get; set; }
		public List<Leaflet> leaflets {get; set; }
		public double score { get; set; }
		public double XX1 { get; set; }
		public double YY1 { get; set; }
		public double XX2 { get; set; }
		public double YY2 { get; set; }
		public string actionData { get; set; }
		public Boolean HasCollided { get; set; }

		private Int32 REDs = 0; //IA006 - André A. Silva
		private Int32 GREENs = 0;//IA006 - André A. Silva
		private Int32 BLUEs = 0;//IA006 - André A. Silva
		private Int32 YELLOWs = 0;//IA006 - André A. Silva
		private Int32 MAGENTAs = 0;//IA006 - André A. Silva
		private Int32 WHITEs = 0;//IA006 - André A. Silva

		private Int32 collectedRED = 0;//IA006 - André A. Silva
		private Int32 collectedGREEN = 0;//IA006 - André A. Silva
		private Int32 collectedBLUE = 0;//IA006 - André A. Silva
		private Int32 collectedYELLOW = 0;//IA006 - André A. Silva
		private Int32 collectedMAGENTA = 0;//IA006 - André A. Silva
		private Int32 collectedWHITE = 0;//IA006 - André A. Silva

		//IA006 - André A. Silva - funções para fazer a contabilidade dos cristais no Leaflet - início
		public void SetLeafletRED(Int32 qtd)
		{
			REDs = qtd;
		}

		public void SetLeafletGREEN(Int32 qtd)
		{
			GREENs = qtd;
		}

		public void SetLeafletBLUE(Int32 qtd)
		{
			BLUEs = qtd;
		}

		public void SetLeafletYELLOW(Int32 qtd)
		{
			YELLOWs = qtd;
		}

		public void SetLeafletMAGENTA(Int32 qtd)
		{
			MAGENTAs = qtd;
		}

		public void SetLeafletWHITE(Int32 qtd)
		{
			WHITEs = qtd;
		}

		public Int32 GetLeafletRED()
		{
			return REDs;
		}

		public Int32 GetLeafletGREEN()
		{
			return GREENs;
		}

		public Int32 GetLeafletBLUE()
		{
			return BLUEs;
		}

		public Int32 GetLeafletYELLOW()
		{
			return YELLOWs;
		}

		public Int32 GetLeafletMAGENTA()
		{
			return MAGENTAs;
		}

		public Int32 GetLeafletWHITE()
		{
			return WHITEs;
		}

		public void SetCollectedRED(Int32 qtd)
		{
			collectedRED = qtd;
		}

		public void SetCollectedGREEN(Int32 qtd)
		{
			collectedGREEN = qtd;
		}

		public void SetCollectedBLUE(Int32 qtd)
		{
			collectedBLUE = qtd;
		}

		public void SetCollectedYELLOW(Int32 qtd)
		{
			collectedYELLOW = qtd;
		}

		public void SetCollectedMAGENTA(Int32 qtd)
		{
			collectedMAGENTA = qtd;
		}

		public void SetCollectedWHITE(Int32 qtd)
		{
			collectedWHITE = qtd;
		}

		public Int32 GetCollectedRED()
		{
			return collectedRED;
		}

		public Int32 GetCollectedGREEN()
		{
			return collectedGREEN;
		}

		public Int32 GetCollectedBLUE()
		{
			return collectedBLUE;
		}

		public Int32 GetCollectedYELLOW()
		{
			return collectedYELLOW;
		}

		public Int32 GetCollectedMAGENTA()
		{
			return collectedMAGENTA;
		}

		public Int32 GetCollectedWHITE()
		{
			return collectedWHITE;
		}
		//IA006 - André A. Silva - funções para fazer a contabilidade dos cristais no Leaflet - fim

		public Dictionary<string,LeafletItem> getConsolidatedLeaflet() {
			Dictionary<string,LeafletItem> m = new Dictionary<string,LeafletItem>();
			LeafletItem li = new LeafletItem("Red",0,0);
			m.Add("Red",li);
			li = new LeafletItem("Green",0,0);
			m.Add("Green",li);
			li = new LeafletItem("Blue",0,0);
			m.Add("Blue",li);
			li = new LeafletItem("Yellow",0,0);
			m.Add("Yellow",li);
			li = new LeafletItem("Magenta",0,0);
			m.Add("Magenta",li);
			li = new LeafletItem("White",0,0);
			m.Add("White",li);
			foreach (Leaflet ll in leaflets) {
				Dictionary<string,LeafletItem> l = ll.getLeaflet();
				foreach(var pair in l) {
					LeafletItem l3 = l[pair.Key];
					LeafletItem glob = m[pair.Key];
					glob.totalNumber += l3.totalNumber;
					glob.collected += l3.collected;
				}
			}
			return(m);
		}

		//IA006 - André A. Silva - função para verificar se todos os Leaflets foram completos
		public Boolean Posso_entregar()
		{
			if (collectedRED >= REDs && collectedGREEN >= GREENs && collectedBLUE >= BLUEs
				&& collectedYELLOW >= YELLOWs && collectedMAGENTA >= MAGENTAs && collectedWHITE >= WHITEs)
				return true;
			else
				return false;
		}

		//IA006 - André A. Silva - função para verificar se determinada cor faz parte dos Leaflets
		public Boolean inLeaflet(string color){

			Dictionary<string,LeafletItem> l = getConsolidatedLeaflet();
			foreach(var pair in l) {
				if (pair.Key == color && pair.Value.totalNumber > 0){
					return true;
				}
			}

			return false;
		}

		public void PrintLeaflet() {
			Dictionary<string,LeafletItem> l = getConsolidatedLeaflet();
			Console.Write("--> ");
			foreach(var pair in l) {
				Console.Write(pair.Key+" "+pair.Value.totalNumber+" "+pair.Value.collected+" "); 
			}
			Console.WriteLine(" ");
		}
	}
}
